diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
index 32902034e..10a3271ae 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
@@ -109,7 +109,7 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implem
     private void updateState(@NotNull World world, @NotNull TilePosc tilePos) {
         int meta = world.getBlockData(tilePos);
         boolean isPressed = isPressed(meta);
-        Direction dir = sideFromMeta(meta).getDirection();
+        Direction dir = sideFromMeta(meta).direction();
         boolean isSteppedOn = false;
         float pixel = 0.125F;
         List<T> list = switch (sideFromMeta(meta)) {
@@ -134,15 +134,15 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implem
             }
         }
         if (isSteppedOn && !isPressed) {
-            world.setBlockDataNotify(tilePos, meta | MASK_POWERED);
-            // world.notifyBlocksOfNeighborChange(tilePos, this.block);
-            world.notifyBlocksOfNeighborChange(tilePos.add(dir, new TilePos()), this.block);
+            world.setBlockData(tilePos, meta | MASK_POWERED);
+            world.markBlockNeedsUpdate(tilePos);
+            world.notifyBlocksInCapsuleOfNeighborChange(dir, tilePos, this.block);
             world.markBlocksDirty(tilePos, tilePos);
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) tilePos.x() + 0.5D, (double) tilePos.y() + 0.1D, (double) tilePos.z() + 0.5D, "random.click", 0.3F, 0.6F);
         } else if (!isSteppedOn && isPressed) {
-            world.setBlockDataNotify(tilePos, meta & ~MASK_POWERED);
-            // world.notifyBlocksOfNeighborChange(tilePos, this.block);
-            world.notifyBlocksOfNeighborChange(tilePos.add(dir, new TilePos()), this.block);
+            world.setBlockData(tilePos, meta & ~MASK_POWERED);
+            world.markBlockNeedsUpdate(tilePos);
+            world.notifyBlocksInCapsuleOfNeighborChange(dir, tilePos, this.block);
             world.markBlocksDirty(tilePos, tilePos);
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) tilePos.x() + 0.5D, (double) tilePos.y() + 0.1D, (double) tilePos.z() + 0.5D, "random.click", 0.3F, 0.5F);
         }
@@ -155,8 +155,7 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implem
     public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
         if (isPressed(data)) {
             Side side = sideFromMeta(world.getBlockData(tilePos));
-            world.notifyBlocksOfNeighborChange(tilePos, this.block);
-            world.notifyBlocksOfNeighborChange(tilePos.add(side.getDirection(), new TilePos()), this.block);
+            world.notifyBlocksInCapsuleOfNeighborChange(side.direction(), tilePos, this.block);
         }
         super.onRemoved(world, tilePos, data);
     }
@@ -185,7 +184,7 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implem
     public boolean isEmittingDirectSignal(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         int meta = world.getBlockData(tilePos);
         if (isPressed(meta)) {
-            return side == sideFromMeta(meta).getOpposite();
+            return side == sideFromMeta(meta).opposite();
         } else {
             return false;
         }
@@ -196,11 +195,11 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implem
     }
 
     public static int setSide(int meta, @NotNull Side side) {
-        return (meta & ~MASK_SIDE) | (side.getId() << 1);
+        return (meta & ~MASK_SIDE) | (side.id << 1);
     }
 
     public static @NotNull Side sideFromMeta(int meta) {
-        return Side.getSideById((meta & MASK_SIDE) >> 1);
+        return Side.fromId((meta & MASK_SIDE) >> 1);
     }
 
     @Override
@@ -216,7 +215,7 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implem
     @Override
     public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         int meta = world.getBlockData(tilePos);
-        side = side.getOpposite();
+        side = side.opposite();
         if (!isSupported(world, tilePos, side)) {
             side = getDefaultSide(world, tilePos);
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumice.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumice.java
index df4f52456..b69ebfa67 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumice.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumice.java
@@ -89,7 +89,7 @@ public class BlockLogicPumice extends BlockLogic {
     @Override
     public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
         if (this.isWet) {
-            Direction direction = Direction.directions[rand.nextInt(6)]; // Get random side
+            Direction direction = Direction.ID_MAP[rand.nextInt(6)]; // Get random side
             if (direction == Direction.UP || world.isBlockOpaqueCube(tilePos.add(direction, new TilePos()))) return;
             float off1 = rand.nextFloat() * 0.9f + 0.05f;
             float off2 = rand.nextFloat() * 0.9f + 0.05f;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkin.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkin.java
index b54fa7cf8..bab15fb27 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkin.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkin.java
@@ -30,7 +30,7 @@ public class BlockLogicPumpkin extends BlockLogicVeryRotatable
         ItemStack heldItem = player.getHeldItem();
         if (heldItem != null && heldItem.getItem() instanceof ItemToolSword){
             heldItem.damageItem(1,player);
-            world.setBlockTypeDataNotify(tilePos, Blocks.PUMPKIN_CARVED_IDLE, player.getHorizontalPlacementDirection(Direction.getHorizontalDirection(player).getSide()).getOpposite().getId());
+            world.setBlockTypeDataNotify(tilePos, Blocks.PUMPKIN_CARVED_IDLE, player.getHorizontalPlacementDirection(Direction.getHorizontalLockable(player).side()).opposite().id);
             return true;
         }
         return false;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkinRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkinRedstone.java
index 381ab4251..3fe46ef80 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkinRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkinRedstone.java
@@ -18,16 +18,13 @@ public class BlockLogicPumpkinRedstone extends BlockLogicVeryRotatable {
 
     @Override
     public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
-        TilePos queryPos = new TilePos();
-        for (Direction dir : Direction.directions){
-            world.notifyBlocksOfNeighborChange(tilePos.add(dir, queryPos), this.block);
-        }
+        world.notifyShellBlocksInRadiusOfNeighborChange(2, tilePos, this.block);
     }
 
     @Override
     public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
         TilePos queryPos = new TilePos();
-        for (Direction dir : Direction.directions){
+        for (final var dir : Direction.all){
             world.notifyBlocksOfNeighborChange(tilePos.add(dir, queryPos), this.block);
         }
     }
@@ -39,8 +36,8 @@ public class BlockLogicPumpkinRedstone extends BlockLogicVeryRotatable {
 
     @Override
     public boolean isEmittingSignal(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Side side) {
-        Side mySide = Side.getSideById(source.getBlockData(tilePos));
-        return mySide == side.getOpposite();
+        Side mySide = Side.fromId(source.getBlockData(tilePos));
+        return mySide == side.opposite();
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
index 029969654..b55e3f37e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
@@ -9,6 +9,7 @@ import net.minecraft.core.block.support.ISupportable;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.util.helper.Axis;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
@@ -134,18 +135,25 @@ public class BlockLogicRail extends BlockLogic implements ISupportable {
             boolean changedMeta = false;
             if (gettingPower && !isPoweredFlagSet) {
                 // Set powered bit
-                world.setBlockDataNotify(tilePos, railDirection.meta | MASK_POWERED);
+                world.setBlockData(tilePos, railDirection.meta | MASK_POWERED);
                 changedMeta = true;
             } else if (!gettingPower && isPoweredFlagSet) {
                 // Remove powered bit
-                world.setBlockDataNotify(tilePos, railDirection.meta);
+                world.setBlockData(tilePos, railDirection.meta);
                 changedMeta = true;
             }
 
+            world.markBlockNeedsUpdate(tilePos);
+
             if (changedMeta) {
-                world.notifyBlocksOfNeighborChange(tilePos.down(queryPos), this.block);
-                if (railDirection.isSloped()) {
-                    world.notifyBlocksOfNeighborChange(tilePos.up(queryPos), this.block);
+                if (!railDirection.isSloped()) {
+                    world.notifyBlocksInCapsuleOfNeighborChange(Direction.DOWN, tilePos, this.block);
+                } else {
+                    world.notifyBlocksOfNeighborChanges(new TilePosc[] {
+                        tilePos,
+                        tilePos.down(queryPos),
+                        tilePos.up(new TilePos()),
+                    }, this.block);
                 }
             }
         } else if (block != null && block.isSignalSource() && new Rail(world, tilePos).getAdjacentTracks() == 3) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java
index c20b3a53b..ebaf81c12 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java
@@ -5,6 +5,7 @@ import java.util.Random;
 
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.vehicle.EntityMinecart;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
@@ -76,15 +77,15 @@ public class BlockLogicRailDetector extends BlockLogicRail {
         }
         if (minecartPresent && !isPowered) {
             // Set rail to powered
-            world.setBlockDataNotify(tilePos, meta | MASK_POWERED);
-            world.notifyBlocksOfNeighborChange(tilePos, this.block);
-            world.notifyBlocksOfNeighborChange(tilePos.down(new TilePos()), this.block);
+            world.setBlockData(tilePos, meta | MASK_POWERED);
+            world.markBlockNeedsUpdate(tilePos);
+            world.notifyBlocksInCapsuleOfNeighborChange(Direction.DOWN, tilePos, this.block);
             world.markBlockDirty(tilePos);
         } else if (!minecartPresent && isPowered) {
             // Set rail to unpowered
-            world.setBlockDataNotify(tilePos, meta & ~MASK_POWERED);
-            world.notifyBlocksOfNeighborChange(tilePos, this.block);
-            world.notifyBlocksOfNeighborChange(tilePos.down(new TilePos()), this.block);
+            world.setBlockData(tilePos, meta & ~MASK_POWERED);
+            world.markBlockNeedsUpdate(tilePos);
+            world.notifyBlocksInCapsuleOfNeighborChange(Direction.DOWN, tilePos, this.block);
             world.markBlockDirty(tilePos);
         }
         if (minecartPresent) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRedstone.java
index 3b548f2df..b5c8862f7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRedstone.java
@@ -33,18 +33,12 @@ public class BlockLogicRedstone extends BlockLogic {
 
     @Override
     public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
-        TilePos queryPos = new TilePos();
-        for (Direction dir : Direction.directions) {
-            world.notifyBlocksOfNeighborChange(tilePos.add(dir, queryPos), this.block);
-        }
+        world.notifyBlocksInRadiusOfNeighborChange(2, tilePos, this.block);
     }
 
     @Override
     public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
-        TilePos queryPos = new TilePos();
-        for (Direction dir : Direction.directions) {
-            world.notifyBlocksOfNeighborChange(tilePos.add(dir, queryPos), this.block);
-        }
+        world.notifyBlocksInRadiusOfNeighborChange(2, tilePos, this.block);
     }
 
 
@@ -56,38 +50,38 @@ public class BlockLogicRedstone extends BlockLogic {
 
         final double d = 0.0625;
         TilePos queryPos = new TilePos();
-        for (Direction dir : Direction.directions) {
+        for (final var dir : Direction.all) {
             double px = (double) tilePos.x() + random.nextFloat();
             double py = (double) tilePos.y() + random.nextFloat();
             double pz = (double) tilePos.z() + random.nextFloat();
             switch (dir) {
                 case DOWN:
-                    if (!world.isBlockOpaqueCube(tilePos.add(dir.getOpposite(), queryPos))) {
+                    if (!world.isBlockOpaqueCube(tilePos.add(dir.opposite(), queryPos))) {
                         py = (tilePos.y() + 1) + d;
                     }
                     break;
                 case UP:
-                    if (!world.isBlockOpaqueCube(tilePos.add(dir.getOpposite(), queryPos))) {
+                    if (!world.isBlockOpaqueCube(tilePos.add(dir.opposite(), queryPos))) {
                         py = (tilePos.y() + 0) - d;
                     }
                     break;
                 case NORTH:
-                    if (!world.isBlockOpaqueCube(tilePos.add(dir.getOpposite(), queryPos))) {
+                    if (!world.isBlockOpaqueCube(tilePos.add(dir.opposite(), queryPos))) {
                         pz = (tilePos.z() + 1) + d;
                     }
                     break;
                 case SOUTH:
-                    if (!world.isBlockOpaqueCube(tilePos.add(dir.getOpposite(), queryPos))) {
+                    if (!world.isBlockOpaqueCube(tilePos.add(dir.opposite(), queryPos))) {
                         pz = (tilePos.z() + 0) - d;
                     }
                     break;
                 case WEST:
-                    if (!world.isBlockOpaqueCube(tilePos.add(dir.getOpposite(), queryPos))) {
+                    if (!world.isBlockOpaqueCube(tilePos.add(dir.opposite(), queryPos))) {
                         px = (tilePos.x() + 1) + d;
                     }
                     break;
                 case EAST:
-                    if (!world.isBlockOpaqueCube(tilePos.add(dir.getOpposite(), queryPos))) {
+                    if (!world.isBlockOpaqueCube(tilePos.add(dir.opposite(), queryPos))) {
                         px = (tilePos.x() + 0) - d;
                     }
                     break;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java
index b4a081d48..7fa8e6d3f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java
@@ -67,17 +67,22 @@ public class BlockLogicRepeater extends BlockLogic implements ISupportable {
 
     @Override
     public boolean canStay(@NotNull World world, @NotNull TilePosc tilePos) {
-        return world.canPlaceOnSurfaceOfBlock(tilePos.down(new TilePos())) && super.canStay(world, tilePos);
+        return this.isSupported(world, tilePos, Side.BOTTOM) && super.canStay(world, tilePos);
     }
 
     @Override
     public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
         int meta = world.getBlockData(tilePos);
         boolean powered = isGettingPower(world, tilePos, meta);
+        var side = getSideFromMeta(meta);
         if (this.isRepeaterPowered && !powered) {
-            world.setBlockTypeDataNotify(tilePos, Blocks.REPEATER_IDLE, meta);
+            world.setBlockTypeDataRaw(tilePos, Blocks.REPEATER_IDLE, meta);
+            world.markBlockNeedsUpdate(tilePos);
+            world.notifyBlocksInCapsuleOfNeighborChange(side.opposite(), tilePos, Blocks.REPEATER_IDLE);
         } else if (!this.isRepeaterPowered) {
-            world.setBlockTypeDataNotify(tilePos, Blocks.REPEATER_ACTIVE, meta);
+            world.setBlockTypeDataRaw(tilePos, Blocks.REPEATER_ACTIVE, meta);
+            world.markBlockNeedsUpdate(tilePos);
+            world.notifyBlocksInCapsuleOfNeighborChange(side.opposite(), tilePos, Blocks.REPEATER_IDLE);
             if (!powered) {
                 int tickDelay = (meta & MASK_TICK_DELAY) >> 2;
                 world.scheduleBlockUpdate(tilePos, Blocks.REPEATER_ACTIVE, tickDelayMap[tickDelay] * 2);
@@ -96,8 +101,8 @@ public class BlockLogicRepeater extends BlockLogic implements ISupportable {
     @Override
     public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
         Side back = getSideFromMeta(data);
-        Side front = back.getOpposite();
-        world.notifyBlocksOfNeighborChange(tilePos.add(front.getDirection(), new TilePos()), this.block);
+        Side front = back.opposite();
+        world.notifyBlocksOfNeighborChange(tilePos.add(front.direction(), new TilePos()), this.block);
     }
 
     @Override
@@ -144,7 +149,7 @@ public class BlockLogicRepeater extends BlockLogic implements ISupportable {
         Side direction = getSideFromMeta(meta);
         if (direction.isVertical()) return false;
 
-        TilePos p = tilePos.add(direction.getDirection(), new TilePos());
+        TilePos p = tilePos.add(direction.direction(), new TilePos());
         return world.hasSignal(p, direction) || (world.getBlockType(p) == Blocks.WIRE_REDSTONE && (world.getBlockData(p) & BlockLogicWireRedstone.MASK_POWER) != 0);
     }
 
@@ -168,7 +173,7 @@ public class BlockLogicRepeater extends BlockLogic implements ISupportable {
 
     @Override
     public void onPlacedByMob(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, @NotNull Mob mob, double xHit, double yHit) {
-        int l = mob.getHorizontalPlacementDirection(side).index;
+        int l = mob.getHorizontalPlacementDirection(side).legacyIndex();
         world.setBlockDataNotify(tilePos, l);
         if (isGettingPower(world, tilePos, l)) {
             world.scheduleBlockUpdate(tilePos, this.block, 1);
@@ -178,7 +183,7 @@ public class BlockLogicRepeater extends BlockLogic implements ISupportable {
     @Override
     public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         if (!side.isHorizontal()) side = Side.NORTH;
-        int l = side.getDirection().index;
+        int l = side.direction().legacyIndex();
         world.setBlockDataNotify(tilePos, l);
         if (isGettingPower(world, tilePos, l)) {
             world.scheduleBlockUpdate(tilePos, this.block, 1);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRotatable.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRotatable.java
index b446cf34a..df176e776 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRotatable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRotatable.java
@@ -17,22 +17,22 @@ public abstract class BlockLogicRotatable extends BlockLogic {
     }
 
     public static @NotNull Direction getDirectionFromMeta(int meta) {
-        return Direction.getDirectionById(meta & MASK_DIRECTION);
+        return Direction.fromId(meta & MASK_DIRECTION);
     }
 
     public static int setDirection(int meta, Direction direction) {
-        return (meta & ~MASK_DIRECTION) | direction.getId();
+        return (meta & ~MASK_DIRECTION) | direction.id;
     }
 
     @Override
     public void onPlacedByMob(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, @NotNull Mob mob, double xHit, double yHit) {
-        world.setBlockDataNotify(tilePos, mob.getHorizontalPlacementDirection(side).getOpposite().getId());
+        world.setBlockDataNotify(tilePos, mob.getHorizontalPlacementDirection(side).opposite().id);
     }
 
     @Override
     public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         if (!side.isHorizontal()) side = Side.SOUTH;
-        world.setBlockDataNotify(tilePos, BlockLogicRotatable.setDirection(0, side.getDirection()));
+        world.setBlockDataNotify(tilePos, BlockLogicRotatable.setDirection(0, side.direction()));
     }
 
     public static void setDefaultDirection(@NotNull World world, @NotNull TilePosc tilePos) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglass.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglass.java
index 73e0d2fa8..79e2988bf 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglass.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglass.java
@@ -36,13 +36,12 @@ public class BlockLogicRubyglass extends BlockLogic
         }
 
         if (rand.nextInt(10) == 0) {
-            final int dir = rand.nextInt(6);
-            final @NotNull Direction direction = Direction.getDirectionById(dir);
+            final @NotNull Direction direction = Direction.ID_MAP[rand.nextInt(6)];
 
             final @NotNull TilePos checkPos = tilePos.add(direction, new TilePos());
             final @NotNull Block<?> checkBlock = world.getBlockType(checkPos);
             if (checkBlock == Blocks.AIR) {
-                world.spawnParticle("rubyglassLightning", tilePos.x(), tilePos.y(), tilePos.z(), 0, 0, 0, dir, 1600d, true);
+                world.spawnParticle("rubyglassLightning", tilePos.x(), tilePos.y(), tilePos.z(), 0, 0, 0, direction.id, 1600d, true);
             }
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassSprout.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassSprout.java
index 35fff8255..026c98085 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassSprout.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassSprout.java
@@ -32,7 +32,7 @@ public class BlockLogicRubyglassSprout extends BlockLogic {
             || (side == Side.WEST && world.isBlockNormalCube(tilePos.east(temp)))
             || (side == Side.BOTTOM && world.isBlockNormalCube(tilePos.up(temp)))
             || (side == Side.TOP && world.isBlockNormalCube(tilePos.down(temp)))) {
-            world.setBlockDataNotify(tilePos, BlockLogicRotatable.setDirection(0, side.getDirection()));
+            world.setBlockDataNotify(tilePos, BlockLogicRotatable.setDirection(0, side.direction()));
         } else {
             world.setBlockDataNotify(tilePos, BlockLogicRotatable.setDirection(0, getOrientation(world, tilePos)));
         }
@@ -43,26 +43,26 @@ public class BlockLogicRubyglassSprout extends BlockLogic {
         final @NotNull TilePos temp = new TilePos();
         if(world.isBlockNormalCube(tilePos.west(temp)))
         {
-            return Side.EAST.getDirection();
+            return Side.EAST.direction();
         }
         if(world.isBlockNormalCube(tilePos.east(temp)))
         {
-            return Side.WEST.getDirection();
+            return Side.WEST.direction();
         }
         if(world.isBlockNormalCube(tilePos.south(temp)))
         {
-            return Side.NORTH.getDirection();
+            return Side.NORTH.direction();
         }
         if (world.isBlockNormalCube(tilePos.north(temp))){
-            return  Side.SOUTH.getDirection();
+            return  Side.SOUTH.direction();
         }
         if (world.isBlockNormalCube(tilePos.down(temp))){
-            return  Side.TOP.getDirection();
+            return  Side.TOP.direction();
         }
         if (world.isBlockNormalCube(tilePos.up(temp))){
-            return  Side.BOTTOM.getDirection();
+            return  Side.BOTTOM.direction();
         }
-        return Side.TOP.getDirection();
+        return Side.TOP.direction();
     }
 
     @Override
@@ -170,7 +170,7 @@ public class BlockLogicRubyglassSprout extends BlockLogic {
         {
             direction = Direction.DOWN;
         }
-        world.setBlockDataNotify(tilePos, direction.getId());
+        world.setBlockDataNotify(tilePos, direction.id);
     }
 
     @Override
@@ -190,7 +190,7 @@ public class BlockLogicRubyglassSprout extends BlockLogic {
     }
 
     public static Direction metaToDirection(int meta) {
-        return Direction.getDirectionById(meta & MASK_DIRECTION);
+        return Direction.fromId(meta & MASK_DIRECTION);
     }
 
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java
index 9dfd95b90..cd85f0a6f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java
@@ -82,12 +82,6 @@ public class BlockLogicSlab extends BlockLogic
         return (meta & MASK_STATE) == STATE_DOUBLE;
     }
 
-    @Override
-    public boolean canPlaceOnSurfaceOnCondition(@NotNull World world, @NotNull TilePosc tilePos) {
-        int meta = world.getBlockData(tilePos);
-        return (meta & MASK_STATE) != STATE_LOWER;
-    }
-
     @Override
     public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         int state = world.getBlockData(tilePos) & MASK_STATE;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java
index 185255109..8236bc71d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java
@@ -46,16 +46,16 @@ public class BlockLogicSpikes extends BlockLogic
             meta |= MASK_POWERED;
         }
 
-        Direction placeDir = sidePlacedOnto.getOpposite().getDirection();
+        Direction placeDir = sidePlacedOnto.opposite().direction();
 
         if (mob instanceof Player player) {
-            if (player.rotationLock != null && player.rotationLock != Direction.NONE) {
+            if (player.rotationLock != null) {
                 placeDir = player.rotationLock;
             }
         }
 
         meta &= ~MASK_DIRECTION;
-        meta |= ((placeDir.getId() << 1) & MASK_DIRECTION);
+        meta |= placeDir.id << 1;
 
         world.setBlockDataNotify(tilePos, meta);
     }
@@ -145,7 +145,7 @@ public class BlockLogicSpikes extends BlockLogic
     }
 
     public static @NotNull Direction getDirectionFromData(int data) {
-        return Direction.getDirectionById((data & MASK_DIRECTION) >> 1);
+        return Direction.fromId((data & MASK_DIRECTION) >> 1);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java
index 171e60515..2a1c03195 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java
@@ -51,8 +51,7 @@ public class BlockLogicSponge extends BlockLogic {
 
     public boolean inWater(@NotNull World world, @NotNull TilePosc tilePos) {
         TilePos queryPos = new TilePos();
-        for (int i = 0; i < Direction.directions.length; i++) {
-            Direction dir = Direction.directions[i];
+        for (final var dir : Direction.all) {
             Block<?> b = world.getBlockType(tilePos.add(dir, queryPos));
             if (Blocks.hasTag(b, BlockTags.IS_WATER)) return true;
         }
@@ -61,8 +60,7 @@ public class BlockLogicSponge extends BlockLogic {
 
     public boolean inHot(@NotNull World world, @NotNull TilePosc tilePos) {
         TilePos queryPos = new TilePos();
-        for (int i = 0; i < Direction.directions.length; i++) {
-            Direction dir = Direction.directions[i];
+        for (final var dir : Direction.all) {
             Block<?> b = world.getBlockType(tilePos.add(dir, queryPos));
             if (b == Blocks.MAGMA || Blocks.hasTag(b, BlockTags.IS_LAVA)) return true;
         }
@@ -89,7 +87,7 @@ public class BlockLogicSponge extends BlockLogic {
     public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
         if (this.isWet) {
             Side side = Side.sides[rand.nextInt(6)]; // Get random side
-            if (side == Side.TOP || world.isBlockOpaqueCube(tilePos.add(side.getDirection(), new TilePos()))) return;
+            if (side == Side.TOP || world.isBlockOpaqueCube(tilePos.add(side.direction(), new TilePos()))) return;
             float off1 = rand.nextFloat() * 0.9f + 0.05f;
             float off2 = rand.nextFloat() * 0.9f + 0.05f;
             float lOff = 0.01f; // Dumb offset to fix bad lighting
